Bug 575529 - Review Request: dwm - Dynamic window manager
Summary: Review Request: dwm - Dynamic window manager
Status: CLOSED DUPLICATE of bug 643375
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review   
(Show other bugs)
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Christoph Wickert
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-03-21 10:48 UTC by Damien Durand
Modified: 2010-10-16 16:37 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-09-14 10:58:07 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
fix spec file (1018 bytes, patch)
2010-05-04 21:17 UTC, François Cami
no flags Details | Diff
fix desktop file (227 bytes, patch)
2010-05-04 21:18 UTC, François Cami
no flags Details | Diff
fix dwm.desktop file PATH (342 bytes, patch)
2010-05-05 16:34 UTC, François Cami
no flags Details | Diff

Description Damien Durand 2010-03-21 10:48:59 UTC
Spec URL: http://fedorapeople.org/~splinux/dwm/dwm.spec
SRPM URL: http://fedorapeople.org/~splinux/dwm/dwm-5.7.2-1.fc13.src.rpm
Description: dwm is an extremely fast, small, and dynamic window manager for X

Comment 1 François Cami 2010-05-04 21:17:05 UTC
Please note that I am not a packager, so this review is not binding.

 - = N/A
 X = Check
 ! = Problem
 ? = Not evaluated

MUST
 [X] rpmlint must be run on every package. The output should be posted in the
review.

=> 0 packages and 1 specfiles checked; 0 errors, 0 warnings.

 [X] The package must be named according to the Package Naming Guidelines.
 [X] The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption.
 [X] The package must meet the Packaging Guidelines.
 [X] The package must be licensed with a Fedora approved license and meet the
Licensing Guidelines.
 [X] The License field in the package spec file must match the actual license.
 [X] If (and only if) the source package includes the text of the license(s) in
its own file, then that file, containing the text of the license(s) for the
package must be included in %doc.
 [X] The spec file must be written in American English.
 [X] The spec file for the package MUST be legible.
 [X] The sources used to build the package must match the upstream source, as
provided in the spec URL. Reviewers should use md5sum for this task. If no
upstream URL can be specified for this package, please see the Source URL
Guidelines for how to deal with this.
 [X] The package MUST successfully compile and build into binary rpms on at
least one primary architecture.

=> tested on Fedora 12 x86_64.

 [X] If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line.
 [X] All build dependencies must be listed in BuildRequires, except for any
that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.
 [-] The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
 [-] Every binary RPM package (or subpackage) which stores shared library files
(not just symlinks) in any of the dynamic linker's default paths, must call
ldconfig in %post and %postun.
 [X] Packages must NOT bundle copies of system libraries.
 [-] If the package is designed to be relocatable, the packager must state this
fact in the request for review, along with the rationalization for relocation
of that specific package. Without this, use of Prefix: /usr is considered a
blocker.
 [X] A package must own all directories that it creates. If it does not create
a directory that it uses, then it should require a package which does create
that directory.
 [X] A Fedora package must not list a file more than once in the spec file's
%files listings.
 [X] Permissions on files must be set properly. Executables should be set with
executable permissions, for example. Every %files section must include a
%defattr(...) line.
 [X] Each package must consistently use macros.
 [X] The package must contain code, or permissable content.
 [X] Large documentation files must go in a -doc subpackage. (The definition of
large is left up to the packager's best judgement, but is not restricted to
size. Large can refer to either size or quantity).
 [X] If a package includes something as %doc, it must not affect the runtime of
the application. To summarize: If it is in %doc, the program must run properly
if it is not present.
 [-] Header files must be in a -devel package.
 [-] Static libraries must be in a -static package.
 [-] If a package contains library files with a suffix (e.g. libfoo.so.1.1),
then library files that end in .so (without suffix) must go in a -devel
package.
 [-] In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release}
 [X] Packages must NOT contain any .la libtool archives, these must be removed
in the spec if they are built.
 [!] Packages containing GUI applications must include a %{name}.desktop file,
and that file must be properly installed with desktop-file-install in the
%install section. If you feel that your packaged GUI application does not need
a .desktop file, you must put a comment in the spec file with your explanation.

=> see attached patches to .spec and .desktop to fix that.

 [X] Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another
package owns, then please present that at package review time.
 [X] At the beginning of %install, each package MUST run rm -rf %{buildroot}
(or $RPM_BUILD_ROOT).
 [X] All filenames in rpm packages must be valid UTF-8.
SHOULD
 [-] If the source package does not include license text(s) as a separate file
from upstream, the packager SHOULD query upstream to include it.
 [!] The description and summary sections in the package spec file should
contain translations for supported Non-English languages, if available.
 [?] The reviewer should test that the package builds in mock.

=> Not done. However, I tested using koji:

$ koji build --scratch dist-f13 dwm-5.7.2-1.fc13.src.rpm
Uploading srpm: dwm-5.7.2-1.fc13.src.rpm
[====================================] 100% 00:00:02  22.25 KiB  10.87 KiB/sec
Created task: 2162289
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=2162289
None
Watching tasks (this may be safely interrupted)...
2162289 build (dist-f13, dwm-5.7.2-1.fc13.src.rpm): free
2162289 build (dist-f13, dwm-5.7.2-1.fc13.src.rpm): free -> open (ppc04.phx2.fedoraproject.org)
  2162291 buildArch (dwm-5.7.2-1.fc13.src.rpm, x86_64): free
  2162292 buildArch (dwm-5.7.2-1.fc13.src.rpm, i686): free
  2162291 buildArch (dwm-5.7.2-1.fc13.src.rpm, x86_64): free -> open (x86-04.phx2.fedoraproject.org)
  2162292 buildArch (dwm-5.7.2-1.fc13.src.rpm, i686): free -> open (x86-02.phx2.fedoraproject.org)
  2162291 buildArch (dwm-5.7.2-1.fc13.src.rpm, x86_64): open (x86-04.phx2.fedoraproject.org) -> closed
  0 free  2 open  1 done  0 failed
  2162292 buildArch (dwm-5.7.2-1.fc13.src.rpm, i686): open (x86-02.phx2.fedoraproject.org) -> closed
  0 free  1 open  2 done  0 failed
2162289 build (dist-f13, dwm-5.7.2-1.fc13.src.rpm): open (ppc04.phx2.fedoraproject.org) -> closed
  0 free  0 open  3 done  0 failed

2162289 build (dist-f13, dwm-5.7.2-1.fc13.src.rpm) completed successfully

 [X] The package should compile and build into binary rpms on all supported
architectures.
 [X] The reviewer should test that the package functions as described. A
package should not segfault instead of running, for example.
 [-] If scriptlets are used, those scriptlets must be sane. This is vague, and
left up to the reviewers judgement to determine sanity.
 [-] Usually, subpackages other than devel should require the base package
using a fully versioned dependency.
 [-] The placement of pkgconfig(.pc) files depends on their usecase, and this
is usually for development purposes, so should be placed in a -devel pkg. A
reasonable exception is that the main pkg itself is a devel tool not installed
in a user runtime, e.g. gcc or gdb.
 [X] If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself.
 [X] your package should contain man pages for binaries/scripts. If it doesn't,
work with upstream to add them where they make sense.

Comment 2 François Cami 2010-05-04 21:17:47 UTC
Created attachment 411413 [details]
fix spec file

Comment 3 François Cami 2010-05-04 21:18:12 UTC
Created attachment 411414 [details]
fix desktop file

Comment 4 François Cami 2010-05-04 21:40:33 UTC
  [X] The package should compile and build into binary rpms on all supported
architectures.

should read:

 [?] The package should compile and build into binary rpms on all supported
architectures.

Comment 5 François Cami 2010-05-05 06:28:58 UTC
In fact, you were right in using $RPM_BUILD_ROOT%{_datadir}/xsessions/ as PATH for the desktop file, but it still _must_ be installed using desktop-file-install.

Could you please post an updated spec file?

Thanks

Comment 6 Damien Durand 2010-05-05 11:39:20 UTC
Hello, the spec file is updated but there is a bug, we can't choose DWM with GDM...

Spec: http://splinux.fedorapeople.org/dwm/dwm.spec
SRPM: http://splinux.fedorapeople.org/dwm/dwm-5.7.2-2.fc13.src.rpm

Comment 7 François Cami 2010-05-05 16:34:33 UTC
Created attachment 411671 [details]
fix dwm.desktop file PATH

Comment 8 François Cami 2010-05-05 16:38:05 UTC
Sorry, my fault:
* the first patch broke the path to the dwm.desktop file (see comment 5)
* I used startx with .xinitrc to test dwm, not gdm.
The attached patch should fix the issue, and dwm appears in gdm.
Could you please post updated spec and src.rpm packages?

Comment 10 François Cami 2010-05-05 18:55:36 UTC
I am not sure what kind of Type and Category (in the .desktop file) this belongs to. Other than that, it looks good. Thanks!

Comment 11 Damien Durand 2010-05-17 11:08:27 UTC
Hello

Did you have some news about the desktop file ?

Comment 13 François Cami 2010-07-22 21:08:52 UTC
Hi Damien,

It seems that window managers don't use Type nor Category (see the icewm and fluxbox packages for example). Could you update the desktop file in the package?

Your current dwm.spec passes rpmlint:
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

Thanks

Comment 14 François Cami 2010-07-22 21:11:53 UTC
And your current package does as well:
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Comment 15 Christoph Wickert 2010-07-22 23:25:52 UTC
(In reply to comment #5)
> In fact, you were right in using $RPM_BUILD_ROOT%{_datadir}/xsessions/ as PATH
> for the desktop file, but it still _must_ be installed using
> desktop-file-install.

No, this rule only applies to desktop files that create menu entries. We have other desktop files for xsession entries, xfce4-panel plugins, kde services and many more. These are not necessarily flowing the freedesktop specs and thus cannot be installed with desktop-file-utils. This means that the desktop file is ok for this package.

But there is another problem: Quoting from http://dwm.suckless.org/

Because dwm is customized through editing its source code, it’s pointless to make binary packages of it. This keeps its userbase small and elitist. No novices asking stupid questions. There are some distributions that provide binary packages though.

Damien, are you sure you want to package this? If you are willing to maintain this, I'll go ahead and do an official review, but IMHO you really should think about this twice.

Comment 16 Jason Tibbitts 2010-10-16 16:37:30 UTC

*** This bug has been marked as a duplicate of bug 643375 ***


Note You need to log in before you can comment on or make changes to this bug.